// CAcquisistion.cpp: implementation of the CCAcquisistion class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "CAcquisistion.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CCAcquisistion::CCAcquisistion()
{

}

CCAcquisistion::~CCAcquisistion()
{

}

DWORD CCAcquisistion::OpenDevice(ULONG num_device)
{

	return DRV_DeviceOpen (num_device,&lDriverHandle); 

}

CString  CCAcquisistion::GetErrorDescription(DWORD dwErrorCode)
{
	char szErrMsg [180];
	
	DRV_GetErrorMessage (dwErrorCode, szErrMsg);
	
	CString error_message = szErrMsg ;

	return error_message ; 

}


DWORD CCAcquisistion::ConfigureAIChannel(USHORT channel, USHORT gain_code)
{
	

	AIConfig[channel].DasChan = channel; 
	AIVoltageIn[channel].chan = channel;

	AIConfig[channel].DasGain = gain_code;             
	AIVoltageIn[channel].gain = gain_code;


	AIVoltageIn[channel].TrigMode = 0 ; 
	AIVoltageIn[channel].voltage = &AIvoltage[channel];

	return DRV_AIConfig (lDriverHandle, &AIConfig[channel]); 

}


DWORD CCAcquisistion::Read_AI_channel(USHORT channel, float *valeur)
{
	DWORD dwErrCde ; 
	
	if ( (dwErrCde = DRV_AIConfig (lDriverHandle, &AIConfig[channel])) != SUCCESS)
			return dwErrCde; 
	
	dwErrCde = DRV_AIVoltageIn(lDriverHandle, &AIVoltageIn[channel]); 

	*valeur = AIvoltage[channel];

	return dwErrCde; 
}


DWORD CCAcquisistion::ConfigureAOChannel(USHORT channel, USHORT RefSrc, FLOAT MaxValue, FLOAT MinValue)
{
	AOConfig[channel].chan = channel ;
	AOConfig[channel].RefSrc = RefSrc ;
	AOConfig[channel].MaxValue = MaxValue ;
	AOConfig[channel].MinValue = MinValue ;

	 

	return DRV_AOConfig (lDriverHandle,&AOConfig[channel]);

}


DWORD CCAcquisistion::Write_AO_channel(USHORT channel, float voltage)
{
	
	
	AOVoltageOut[channel].chan = channel ;
	AOVoltageOut[channel].OutputValue = voltage ; 


	return DRV_AOVoltageOut (lDriverHandle,&AOVoltageOut[channel]);
	

}



void CCAcquisistion::CloseDevice()
{
	 DRV_DeviceClose (&lDriverHandle); 
}






