// TER_Banc_MoteurDlg.cpp : implementation file
//

#include "stdafx.h"
#include "TER_Banc_Moteur.h"
#include "TER_Banc_MoteurDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CTER_Banc_MoteurDlg dialog

CTER_Banc_MoteurDlg::CTER_Banc_MoteurDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CTER_Banc_MoteurDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CTER_Banc_MoteurDlg)
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	//m_hIcon = AfxGetApp()->LoadIcon(IDI_LSIS);
}

void CTER_Banc_MoteurDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CTER_Banc_MoteurDlg)
	DDX_Control(pDX, IDC_PROGRESS, m_Progress);
	DDX_Control(pDX, IDC_TAB1, m_TabCtrl);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CTER_Banc_MoteurDlg, CDialog)
	//{{AFX_MSG_MAP(CTER_Banc_MoteurDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_BUTTON_STOP, OnButtonStop)
	ON_BN_CLICKED(IDOK, OnQuitter)
	ON_BN_CLICKED(IDC_BUTTON_LIRE_FIC, OnButtonLireFic)
	ON_BN_CLICKED(IDC_BUTTON_DEMAR, OnButtonDemar)
	ON_COMMAND(IDM_EXIT, OnQuitter)
	ON_COMMAND(ID_ABOUT, OnAbout)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTER_Banc_MoteurDlg message handlers

BOOL CTER_Banc_MoteurDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	m_OngletBO.m_intPeriode = m_intTps;
	m_OngletBF.m_intPeriode = m_intTps;

	int nPageID = 0;

	m_OngletBO.Create (IDD_DIALOG_TAB_BO, this);
	m_TabCtrl.AddSSLPage (_T("Boucle Ouverte"), nPageID++, &m_OngletBO);
	m_OngletBF.Create (IDD_DIALOG_TAB_BF, this);
	m_TabCtrl.AddSSLPage (_T("Boucle Ferme"), nPageID++, &m_OngletBF);
	m_OngletVib.Create (IDD_DIALOG_TAB_VIB, this);
	m_TabCtrl.AddSSLPage (_T("Vibrations"), nPageID++, &m_OngletVib);
	
	// TODO: Add extra initialization here

	m_bMoteurStopped = TRUE;
	m_bDeviceOpened = FALSE;
	m_bLectureFic = FALSE;
	
	ShowWindow(SW_SHOWMAXIMIZED);

	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CTER_Banc_MoteurDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CTER_Banc_MoteurDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CTER_Banc_MoteurDlg::OnTimer(UINT nIDEvent) 
{
	m_bMoteurStopped = !(m_OngletBO.m_bRedemarrer || m_OngletBF.m_bRedemarrer);

	if (nIDEvent == 2)
	{
		// Acquisition Vibrations
		
		DWORD error_code;
		float mesure_vib;
	
 		if ( (error_code= m_CarteAcqui.Read_AI_channel( 2 , &mesure_vib)) != SUCCESS)
		{ 	
			CString desc_error = m_CarteAcqui.GetErrorDescription ( error_code);	
 			MessageBox ( desc_error , "Erreur d'acquisition", MB_OK | MB_ICONERROR);
 			KillTimer(2);
 		}

		static int xvib = 0;
		static int xvibmax = 100;
		if (xvib > xvibmax)
		{
			xvibmax = xvib;
			MAJGraphVib(xvibmax);
		}

		m_OngletVib.m_graphVib.PlotXY(xvib,mesure_vib*10.,0);

		xvib++;
		
		CDialog::OnTimer(nIDEvent);

		return;
	}
	
	// Acquisition Couple /	Vitesse
	DWORD error_code;
	float mesure_couple, mesure_vitesse;
	
 	if ( (error_code= m_CarteAcqui.Read_AI_channel( 0 , &mesure_couple)) != SUCCESS)
	{ 	
		CString desc_error = m_CarteAcqui.GetErrorDescription ( error_code);	
 		MessageBox ( desc_error , "Erreur d'acquisition", MB_OK | MB_ICONERROR);
 		KillTimer(1);
 	}
	
	if ( (error_code= m_CarteAcqui.Read_AI_channel( 1 , &mesure_vitesse)) != SUCCESS)
	{ 	
		CString desc_error = m_CarteAcqui.GetErrorDescription ( error_code);	
 		MessageBox ( desc_error , "Erreur d'acquisition", MB_OK | MB_ICONERROR);
 		KillTimer(1);
 	}

	// Calcul des commandes et des consignes

	float commande_couple, commande_vitesse; 
	int consigne_couple, consigne_vitesse;

	if (m_bMoteurStopped)
	{
		commande_couple = 0;
		commande_vitesse = 0;
		consigne_couple = 0;
		consigne_vitesse = 0;
	}
	else if (m_bLectureFic)
	{
		CTabComm & tab_com = MyList.GetNext(PosListe);
		
		commande_couple = tab_com.Tab[0]/10;
		commande_vitesse = tab_com.Tab[1]/10;

		m_Progress.SetPos(m_Progress.GetPos()+1);

		if (PosListe==MyList.GetTailPosition())
		{
			m_Progress.SetPos(0);
			m_bLectureFic = FALSE;			
		}
	}
	else if (m_TabCtrl.m_bBoucleOuverte)
	{
		// Boucle ouverte
		consigne_couple = m_OngletBO.BOCouple;
		consigne_vitesse = m_OngletBO.BOVitesse;
		commande_couple = (float)m_OngletBO.BOCouple/10;
		commande_vitesse = (float)m_OngletBO.BOVitesse/10;
	}
	else
	{
		// Boucle ferme
		//========================================================
		//        Algo de rgulation pour le couple.
		//========================================================
		
	    //coef PID
		float Bp=m_OngletBF.Bp;
		float Ti=m_OngletBF.Ti;
		float Ka=m_OngletBF.Ka;
		float Td=m_OngletBF.Td;
		// float td=m_OngletBF.td;

		//va internes PID
		static float e1=0;
		static float e2=0;
		static float P1=0;
		static float I1=0;
		static float I2=0;
		static float diff1=0;
		static float diff2=0;

		static float u1, comm_couple;

		//correcteur PID
	    float cons_couple = ((float)m_OngletBF.BFCouple)/10;
     	e1=cons_couple-mesure_couple;	//calcul de l'erreur
		P1=100.0f/Bp*e1;					//action proportionelle
		I1=I2+((100e-3f)/(2*Ti))*(e1+e2);	//action intgrale
		
		u1=P1+I1;						//calcul de la commande			
		e2=e1;

		comm_couple=u1;

		diff1=comm_couple-u1;

		I1=I1+ (Ka*100e-3/2)*(diff1+diff2);	//anti windup
		I2=I1;
		diff2=diff1;

		//========================================================

		//========================================================
		//        Algo de rgulation pour la vitesse.
		//========================================================
		
		float bps_v=m_OngletBF.bps_v;
		float ti_v=m_OngletBF.ti_v;
		float ka_v=m_OngletBF.ka_v;
		float td_v=m_OngletBF.td_v;

		commande_vitesse=(float)m_OngletBF.BFVitesse/10;

		//========================================================

		consigne_couple = m_OngletBF.BFCouple;
		consigne_vitesse = m_OngletBF.BFVitesse;
		commande_couple = comm_couple;
	}

	// Envoi des commandes
	if(commande_couple>=10)	commande_couple=10;
	if(commande_couple<=0)  commande_couple=0;
	if(commande_vitesse>=10) commande_vitesse=10;
	if(commande_vitesse<=0)  commande_vitesse=0;
	
	if ( (error_code= m_CarteAcqui.Write_AO_channel( 0, commande_couple)) != SUCCESS)
 	{
 		CString desc_error = m_CarteAcqui.GetErrorDescription ( error_code);
 		MessageBox ( desc_error , "Erreur d'acquisition", MB_OK | MB_ICONERROR);
 	}
 	if ( (error_code= m_CarteAcqui.Write_AO_channel( 1, commande_vitesse)) != SUCCESS)
 	{
 		CString desc_error = m_CarteAcqui.GetErrorDescription ( error_code);
 		MessageBox ( desc_error , "Erreur d'acquisition", MB_OK | MB_ICONERROR);
 	}

	// Dessin des courbes
	static int x = 0;
    static int xmax = 100;
	if (x > xmax)
	{
		xmax = x;
		MAJGraphEnt(xmax);
	}

	m_OngletBO.m_scopeBOEntCouple.PlotXY(x,mesure_couple*10.,0);
	m_OngletBO.m_scopeBOEntVitesse.PlotXY(x,mesure_vitesse*10.,0);
	//m_OngletBO.m_scopeBOEntCouple.PlotXY(x,m_OngletBO.BOCouple,1);
	//m_OngletBO.m_scopeBOEntVitesse.PlotXY(x,m_OngletBO.BOVitesse,1);
	
	m_OngletBF.m_scopeBFEntCouple.PlotXY(x,mesure_couple*10.,0);
	m_OngletBF.m_scopeBFEntVitesse.PlotXY(x,mesure_vitesse*10.,0);
	m_OngletBF.m_scopeBFEntCouple.PlotXY(x,m_OngletBF.BFCouple,1);
	m_OngletBF.m_scopeBFEntVitesse.PlotXY(x,m_OngletBF.BFVitesse,1);

	x++;
	
	if (m_TabCtrl.m_bBoucleOuverte)
	{
		static int x_bo = 0;
		static int xmax_bo = 100;
		if (x_bo > xmax_bo)
		{
			xmax_bo = x_bo;
			MAJGraphBO(xmax_bo);
		}

		m_OngletBO.m_scopeBOSortCouple.PlotXY(x_bo,commande_couple*10.,0);
		m_OngletBO.m_scopeBOSortVitesse.PlotXY(x_bo,commande_vitesse*10.,0);

		x_bo++;
	}
	else
	{
		static int x_bf = 0;
		static int x_bfmax = 100;
		if (x_bf > x_bfmax)
		{
			x_bfmax = x_bf;
			MAJGraphBF(x_bfmax);
		}

		m_OngletBF.m_scopeBFSortCouple.PlotXY(x_bf,commande_couple*10.,0);
		m_OngletBF.m_scopeBFSortVitesse.PlotXY(x_bf,commande_vitesse*10.,0);

		x_bf++;
	}

	// Enregistrement des valeurs dans un fichier.
	if (m_TabCtrl.m_bBoucleOuverte && m_OngletBO.m_bEnr)
	{
		fprintf(m_OngletBO.m_FicEnr,"%.2f\t%.2f\t%2.f\t%2.f\n",
					mesure_couple*10., mesure_vitesse*10.,
					commande_couple*10.,commande_vitesse*10.);
		fflush(m_OngletBO.m_FicEnr);
	}


	if ((!m_TabCtrl.m_bBoucleOuverte) && m_OngletBF.m_bEnr)
	{
		fprintf(m_OngletBF.m_FicEnr,"%.2f\t%.2f\t%.2f\t%.2f\t%d\t%d\n",
			mesure_couple*10.,mesure_vitesse*10.,
			commande_couple*10.,commande_vitesse*10.,
			consigne_couple,consigne_vitesse);
		fflush(m_OngletBF.m_FicEnr);
	}

	CDialog::OnTimer(nIDEvent);
}


void CTER_Banc_MoteurDlg::OnButtonStop() 
{
	//TODO: Add your control notification handler code here

	m_OngletBO.m_bRedemarrer = FALSE;
	m_OngletBF.m_bRedemarrer = FALSE;
	m_OngletBO.m_sliderBO.SetPos(0);
	m_OngletBF.m_sliderBF.SetPos(0);

	m_OngletBO.m_strValSlider.Format("0 %c",'%');
	m_OngletBF.m_strValSlider.Format("0 %c",'%');
	m_OngletBO.UpdateData(FALSE);
	m_OngletBF.UpdateData(FALSE);
	
	m_OngletBO.BOCouple = 0;
	m_OngletBO.BOVitesse = 0;
	m_OngletBF.BFCouple=0;
	m_OngletBF.BFVitesse=0;
}

void CTER_Banc_MoteurDlg::MAJGraphBO(int x_max)
{
	m_OngletBO.m_scopeBOSortCouple.SetRange(x_max-100,x_max,0,100);

	m_OngletBO.m_scopeBOSortCouple.SetAnnotation(0);
	m_OngletBO.m_scopeBOSortCouple.SetAnnoLabelX(x_max-95);

	m_OngletBO.m_scopeBOSortVitesse.SetRange(x_max-100,x_max,0,100);
		
	m_OngletBO.m_scopeBOSortVitesse.SetAnnotation(0);
	m_OngletBO.m_scopeBOSortVitesse.SetAnnoLabelX(x_max-95);
}

void CTER_Banc_MoteurDlg::MAJGraphBF(int x_max)
{
	m_OngletBF.m_scopeBFSortCouple.SetRange(x_max-100,x_max,0,100);

	m_OngletBF.m_scopeBFSortCouple.SetAnnotation(0);
	m_OngletBF.m_scopeBFSortCouple.SetAnnoLabelX(x_max-95);

	m_OngletBF.m_scopeBFSortVitesse.SetRange(x_max-100,x_max,0,100);
		
	m_OngletBF.m_scopeBFSortVitesse.SetAnnotation(0);
	m_OngletBF.m_scopeBFSortVitesse.SetAnnoLabelX(x_max-95);
}

void CTER_Banc_MoteurDlg::MAJGraphEnt(int x_max)
{
	m_OngletBO.m_scopeBOEntCouple.SetRange(x_max-100,x_max,0,100);
	m_OngletBO.m_scopeBOEntCouple.SetAnnotation(0);
	m_OngletBO.m_scopeBOEntCouple.SetAnnoLabelX(x_max-95);
	m_OngletBO.m_scopeBOEntCouple.SetAnnotation(1);
	m_OngletBO.m_scopeBOEntCouple.SetAnnoLabelX(x_max-95);
	m_OngletBO.m_scopeBOEntVitesse.SetRange(x_max-100,x_max,0,100);
	m_OngletBO.m_scopeBOEntVitesse.SetAnnotation(0);
	m_OngletBO.m_scopeBOEntVitesse.SetAnnoLabelX(x_max-95);
	m_OngletBO.m_scopeBOEntVitesse.SetAnnotation(1);
	m_OngletBO.m_scopeBOEntVitesse.SetAnnoLabelX(x_max-95);
	
	m_OngletBF.m_scopeBFEntCouple.SetRange(x_max-100,x_max,0,100);
	m_OngletBF.m_scopeBFEntCouple.SetAnnotation(0);
	m_OngletBF.m_scopeBFEntCouple.SetAnnoLabelX(x_max-95);
	m_OngletBF.m_scopeBFEntCouple.SetAnnotation(1);
	m_OngletBF.m_scopeBFEntCouple.SetAnnoLabelX(x_max-95);
	m_OngletBF.m_scopeBFEntVitesse.SetRange(x_max-100,x_max,0,100);
	m_OngletBF.m_scopeBFEntVitesse.SetAnnotation(0);
	m_OngletBF.m_scopeBFEntVitesse.SetAnnoLabelX(x_max-95);	
	m_OngletBF.m_scopeBFEntVitesse.SetAnnotation(1);
	m_OngletBF.m_scopeBFEntVitesse.SetAnnoLabelX(x_max-95);
}

void CTER_Banc_MoteurDlg::OnQuitter() 
{
	// TODO: Add your control notification handler code here
	DWORD error_code;
	
	if (m_OngletBO.FichierCreer)
	{
		fclose(m_OngletBO.m_FicEnr);
	}
	
	if (m_OngletBF.FichierCreer)
	{
		fclose(m_OngletBF.m_FicEnr);
	}

	if (m_bDeviceOpened)
	{
		if ( (error_code= m_CarteAcqui.Write_AO_channel( 0, 0)) != SUCCESS)
 		{
 			CString desc_error = m_CarteAcqui.GetErrorDescription ( error_code);
 			MessageBox ( desc_error , "Erreur d'acquisition", MB_OK | MB_ICONERROR);
 		}
 	
		if ( (error_code= m_CarteAcqui.Write_AO_channel( 1, 0)) != SUCCESS)
 		{
 			CString desc_error = m_CarteAcqui.GetErrorDescription ( error_code);
 			MessageBox ( desc_error , "Erreur d'acquisition", MB_OK | MB_ICONERROR);
		}
	}

	OnOK();
}


// void CTER_Banc_MoteurDlg::OnButtonList() 
// {
// 	// TODO: Add your control notification handler code here
// 	
// 	CString str;
// 
// 	for (POSITION pos = MyList.GetHeadPosition(); 
// 		pos!=MyList.GetTailPosition();)
// 	{	
// 		CTabComm & Temp = MyList.GetNext(pos);
// 		str.Format("%f %f\n",Temp.Tab[0],Temp.Tab[1]);
// 		MessageBox(str);		
// 	}
// }

void CTER_Banc_MoteurDlg::OnButtonLireFic() 
{
	// TODO: Add your control notification handler code here
	CFileDialog openDlg(TRUE,"txt",NULL,OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT,
				"Fichier texte (*.*)|*.*||");

	if (openDlg.DoModal()==IDOK) 
	{
		if (!MyList.IsEmpty())
			MyList.RemoveAll();

		CString m_strPathName = openDlg.GetPathName();
		
		FILE * FicLire = fopen(m_strPathName, "r");
		
		if (!FicLire)
		{
			MessageBox("Erreur lors de l'ouverture du fichier",
					"Erreur",MB_ICONWARNING);
			return;
		}

		char *ret, buf[128];

		while ((ret = fgets(buf,128,FicLire))!=NULL)
		{			
			if (strlen(buf)<=1 || buf[0]=='#')
			{
				// Lignes vides ou commenant par #
				continue;
			}
			CTabComm MyTab;
			int lu = sscanf(buf,"%f %f\n",&(MyTab.Tab[0]),&(MyTab.Tab[1]));
			if (lu != 2)
			{
				MessageBox("Format de fichier non valide",
						"Erreur",MB_ICONWARNING);
				return;
			}
			MyList.AddTail(MyTab);

		}
		
		fclose(FicLire);

		m_bLectureFic = TRUE;

		PosListe = MyList.GetHeadPosition();
		
		m_Progress.SetRange32(0,MyList.GetCount());
		m_Progress.SetStep(1);
	}
}

void CTER_Banc_MoteurDlg::MAJGraphVib(int x_max)
{
	m_OngletVib.m_graphVib.SetRange(x_max-100,x_max,0,100);
}

void CTER_Banc_MoteurDlg::OnButtonDemar() 
{
	// TODO: Add your control notification handler code here
	DWORD error_code ; 

	if (!m_bDeviceOpened)
	{
		m_bDeviceOpened = TRUE;

		if ( (error_code = m_CarteAcqui.OpenDevice( 0)) != SUCCESS)
		{
			CString desc_error = m_CarteAcqui.GetErrorDescription ( error_code);
		
			MessageBox ( desc_error , "Erreur de connexion  la carte d'acquisition",
				MB_OK | MB_ICONERROR);

			this->DestroyWindow();

			return; 
		}

		if ( (error_code= m_CarteAcqui.ConfigureAIChannel( 0 , 0 )) != SUCCESS)
		{
			CString desc_error = m_CarteAcqui.GetErrorDescription ( error_code);		
			MessageBox ( desc_error , "Erreur de configuration channel 0 input", 
				MB_OK | MB_ICONERROR);
		}

		if ( (error_code= m_CarteAcqui.ConfigureAIChannel( 1 , 0 )) != SUCCESS)
		{
			CString desc_error = m_CarteAcqui.GetErrorDescription ( error_code);		
			MessageBox ( desc_error , "Erreur de configuration channel 1 input",
				MB_OK | MB_ICONERROR);
		}

		if ( (error_code= m_CarteAcqui.ConfigureAIChannel( 2 , 0 )) != SUCCESS)
		{
			CString desc_error = m_CarteAcqui.GetErrorDescription ( error_code);		
			MessageBox ( desc_error , "Erreur de configuration channel 2 input",
				MB_OK | MB_ICONERROR);
		}
	
		if ( (error_code= m_CarteAcqui.ConfigureAOChannel( 0, 0, 10 , 0 )) != SUCCESS)
		{
			CString desc_error = m_CarteAcqui.GetErrorDescription ( error_code);		
			MessageBox ( desc_error , "Erreur de configuration channel 0 output",
				MB_OK | MB_ICONERROR);
		}	

		if ( (error_code= m_CarteAcqui.ConfigureAOChannel( 1, 0, 10 , 0 )) != SUCCESS)
		{
			CString desc_error = m_CarteAcqui.GetErrorDescription ( error_code);		
			MessageBox ( desc_error , "Erreur de configuration channel 1 output",
				MB_OK | MB_ICONERROR);
		}	
	

//		if ( (error_code= m_CarteAcqui.ConfigureAOChannel( 2, 0, 10 , 0 )) != SUCCESS)
//		{
//			CString desc_error = m_CarteAcqui.GetErrorDescription ( error_code);		
//			MessageBox ( desc_error , "Erreur de configuration de la carte d'acquisition",
//				MB_OK | MB_ICONERROR);
//		}
	
		SetTimer(1,m_intTps,NULL);

		SetTimer(2,m_intTpsVib,NULL);
	}
}


void CTER_Banc_MoteurDlg::OnAbout() 
{
	// TODO: Add your command handler code here
	CAbout about;
	about.DoModal();
}
