// OngBF.cpp : implementation file
//

#include "stdafx.h"
#include "TER_Banc_Moteur.h"
#include "OngBF.h"
#include "EditTitre.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// COngBF dialog


COngBF::COngBF(CWnd* pParent /*=NULL*/)
	: CTabPageSSL(COngBF::IDD, pParent)
{
	//{{AFX_DATA_INIT(COngBF)
	m_strValSlider = _T("");
	m_iRadioBF = -1;
	m_intValCons = 0;
	m_strCoeff = _T("");
	m_strCoeffV = _T("");
	m_strPeriode = _T("");
	//}}AFX_DATA_INIT
}


void COngBF::DoDataExchange(CDataExchange* pDX)
{
	CTabPageSSL::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(COngBF)
	DDX_Control(pDX, IDC_SLIDERBF, m_sliderBF);
	DDX_Control(pDX, IDC_NTGRAPH_BF_ENT1, m_scopeBFEntCouple);
	DDX_Control(pDX, IDC_NTGRAPH_BF_ENT2, m_scopeBFEntVitesse);
	DDX_Control(pDX, IDC_NTGRAPH_BF_SORT1, m_scopeBFSortCouple);
	DDX_Control(pDX, IDC_NTGRAPH_BF_SORT2, m_scopeBFSortVitesse);
	DDX_Text(pDX, IDC_STATIC_VAL_SLID_BF, m_strValSlider);
	DDX_Radio(pDX, IDC_RADIO_COUPLE_BF, m_iRadioBF);
	DDX_Text(pDX, IDC_EDIT_VAL_CONS, m_intValCons);
	DDV_MinMaxInt(pDX, m_intValCons, 0, 100);
	DDX_Text(pDX, IDC_STATIC_STR_COEFF, m_strCoeff);
	DDX_Text(pDX, IDC_STATIC_PARAM_VITESSE, m_strCoeffV);
	DDX_Text(pDX, IDC_STATIC_PERIODE, m_strPeriode);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(COngBF, CTabPageSSL)
	//{{AFX_MSG_MAP(COngBF)
	ON_WM_HSCROLL()
	ON_BN_CLICKED(IDC_RADIO_COUPLE_BF, OnRadioCoupleBf)
	ON_BN_CLICKED(IDC_RADIO_VITESSE_BF, OnRadioVitesseBf)
	ON_BN_CLICKED(IDC_BUTTON_VAL_CONS, OnButtonValCons)
	ON_BN_CLICKED(IDC_BUTTON_COEFF, OnButtonCoeff)
	ON_BN_CLICKED(IDC_BUTTON_BF_ENR, OnButtonBfEnr)
	ON_BN_CLICKED(IDC_BUTTON_BF_VOIR_ENR, OnButtonBfVoirEnr)
	ON_BN_CLICKED(IDC_BUTTONG1, OnButtong1)
	ON_BN_CLICKED(IDC_BUTTONG2, OnButtong2)
	ON_BN_CLICKED(IDC_BUTTONG3, OnButtong3)
	ON_BN_CLICKED(IDC_BUTTONG4, OnButtong4)
	ON_BN_CLICKED(IDC_BUTTON_DIAG_COEFF_V, OnButtonDiagCoeffV)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// COngBF message handlers

BOOL COngBF::OnInitDialog()
{
	CTabPageSSL::OnInitDialog ();
	
	InitGraph(&m_scopeBFEntCouple,"Bleu : mesure couple / Vert : consigne couple");
	InitGraph(&m_scopeBFEntVitesse,"Bleu : mesure vitesse / Vert : consigne vitesse");
	InitGraph(&m_scopeBFSortCouple,"Commande couple");
	InitGraph(&m_scopeBFSortVitesse,"Commande vitesse");	

	BFCouple = 0;
	BFVitesse = 0;
	m_iRadioBF = 0;

	m_bEnr = FALSE;

	Bp=400;
	Ti=0.1f;
	Ka=.1f;
	Td=0;
	td=0;

	bps_v = 0;
	ti_v = 0;
	td_v = 0;
	ka_v = 0;

	m_strCoeff.Format("Bp=%.2f Ti=%.2f  Td=%.2f Ka=%.2f", 
		Bp, Ti, Td, Ka);

	m_strCoeffV.Format("Bp_v=%.2f Ti_v=%.2f Td_v=%.2f Ka_v=%.2f",
		bps_v,ti_v,td_v,ka_v);

	m_strValSlider.Format("0 %c",'%');
	
	m_strPeriode.Format("Priode d'chantillonnage : %d ms",m_intPeriode);
	
	UpdateData(FALSE);

	m_bRedemarrer = TRUE;

	FichierCreer = FALSE;

	return TRUE;
}

void COngBF::InitGraph(CNTGraph *g, LPCTSTR TitreGraphe, LPCTSTR AnnoLabel,
					   LPCTSTR AnnoLabel2)
{
	g->SetRange(0,100,0,100);
	g->SetYLabel("%");

	g->AddAnnotation();
	g->SetAnnoLabelColor(RGB(192,192,255));
	g->SetAnnoLabelBkColor(RGB(0, 0, 64));
	g->SetAnnoLabelX(5);
	g->SetAnnoLabelY(80);
	g->SetAnnoLabelCaption(AnnoLabel);

	if (AnnoLabel2!=NULL)
	{
		g->AddAnnotation();
		g->SetAnnoLabelColor(RGB(0,255,0));
		g->SetAnnoLabelBkColor(RGB(0, 0, 64));
		g->SetAnnoLabelX(5);
		g->SetAnnoLabelY(70);
		g->SetAnnoLabelCaption(AnnoLabel2);
	}

	if (TitreGraphe != NULL)
	{
		g->SetCaption(TitreGraphe);
	}

	// Customize Graph Properties 
	g->SetShowGrid(FALSE);
	g->SetAxisColor(RGB(192, 192, 255));
	g->SetGridColor(RGB(192, 192, 255));
	g->SetLabelColor (RGB(192, 192, 255));

	// Control's Frame and Plot area options
	g->SetPlotAreaColor(RGB(0, 0, 64));
	g->SetFrameStyle(1);

	g->SetElementWidth(1);
	g->SetElementLinetype(0); // 5 = NULL
	g->SetElementLineColor(RGB(192,192,255));
	g->SetElementPointColor(RGB(0,255,0));
	g->SetElementPointSymbol(0); //1 = POINT
	g->SetElementSolidPoint(TRUE);

	g->AddElement();
	g->SetElementWidth(1);
	g->SetElementLinetype(0); // 5 = NULL
	g->SetElementLineColor(RGB(0,255,0));
	g->SetElementPointColor(RGB(0,255,0));
	g->SetElementPointSymbol(0); // 1 = Point
	g->SetElementSolidPoint(TRUE);
}

void COngBF::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	// TODO: Add your message handler code here and/or call default
	
	if ( (CSliderCtrl*)pScrollBar == &m_sliderBF)
	{
		if (m_iRadioBF == 0)
		{
			BFCouple = m_sliderBF.GetPos();
		}
		else
		{
			BFVitesse = m_sliderBF.GetPos();
		}
	}		
	
	UpdateData(TRUE);

	m_strValSlider.Format("%d %c",m_sliderBF.GetPos(),'%');
	UpdateData(FALSE);

	m_bRedemarrer = TRUE;

	CTabPageSSL::OnHScroll(nSBCode, nPos, pScrollBar);
}

void COngBF::OnRadioCoupleBf() 
{
	// TODO: Add your control notification handler code here
	m_sliderBF.SetPos(BFCouple);
	UpdateData(TRUE);
	m_strValSlider.Format("%d %c",BFCouple,'%');
	UpdateData(FALSE);
	m_bRedemarrer = TRUE;
}

void COngBF::OnRadioVitesseBf() 
{
	// TODO: Add your control notification handler code here
	m_sliderBF.SetPos(BFVitesse);
	UpdateData(TRUE);
	m_strValSlider.Format("%d %c",BFVitesse,'%');
	UpdateData(FALSE);
	m_bRedemarrer = TRUE;
}

void COngBF::OnButtonValCons() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);

	if (m_intValCons<0 || m_intValCons>100)
		return;

	if (m_iRadioBF == 0)
	{
		BFCouple = m_intValCons;
		m_sliderBF.SetPos(BFCouple);
	}
	else
	{
		BFVitesse = m_intValCons;
		m_sliderBF.SetPos(BFVitesse);
	}
	m_strValSlider.Format("%d %c",m_sliderBF.GetPos(),'%');
	UpdateData(FALSE);

	m_bRedemarrer = TRUE;
}

void COngBF::OnButtonCoeff() 
{
	// TODO: Add your control notification handler code here

	if (coeffDlg.DoModal() == IDOK)
	{
		Bp=coeffDlg.m_fBp;
		Ti=coeffDlg.m_fTi;
		Ka=coeffDlg.m_fKa;
		Td=coeffDlg.m_fTd;	
	}

	m_strCoeff.Format("Bp=%.2f Ti=%.2f  Td=%.2f Ka=%.2f", 
		Bp, Ti, Td, Ka);
	
	if (m_bEnr)
	{
		fprintf(m_FicEnr,"=> Nouveaux coefficients de rgulation du couple : %s\n",
			m_strCoeff);
		fflush(m_FicEnr);
	}

	UpdateData(FALSE);
}

void COngBF::OnButtonBfEnr() 
{
	// TODO: Add your control notification handler code here

	if (!m_bEnr)
	{
		if (FichierCreer)
		{
			m_bEnr = TRUE;
			((CButton*)GetDlgItem ( IDC_BUTTON_BF_ENR))->SetWindowText("Arrter");

			CTime time = CTime::GetCurrentTime();
			fprintf(m_FicEnr,"=> Dmarrage %s\n",time.Format("%d/%m/%Y %H:%M:%S"));
		}
		else
		{
			CFileDialog saveDlg(FALSE,"txt",NULL,OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT,
				"Fichier texte (*.*)|*.*||");

			if (saveDlg.DoModal()==IDOK)
				{
					FichierCreer = TRUE;
					((CButton*)GetDlgItem ( IDC_BUTTON_BF_VOIR_ENR))->EnableWindow(TRUE);
					
					m_bEnr = TRUE;
					((CButton*)GetDlgItem ( IDC_BUTTON_BF_ENR))->SetWindowText("Arrter");

					m_strPathName = saveDlg.GetPathName();
		
					m_FicEnr = fopen(m_strPathName, "w");
	
					CTime time = CTime::GetCurrentTime();

					fprintf(m_FicEnr,"Fichiers de log pour la boucle ferme.\n\n");
					fprintf(m_FicEnr,"=> Coefficients de l'algo. de rgulation du couple : %s\n\n",m_strCoeff);
					fprintf(m_FicEnr,"=> Coefficients de l'algo. de rgulation de la vitesse : %s\n\n",m_strCoeffV);
					fprintf(m_FicEnr,"Mesure_couple\tMesure_vitesse\tCommande_couple\tCommande_vitesse\tConsigne_couple\tConsigne_vitesse\n\n");
					fprintf(m_FicEnr,"=> Dmarrage %s\n",time.Format("%d/%m/%Y %H:%M:%S"));
				}
		}
	}
	else
	{
		m_bEnr = FALSE;

		CTime time = CTime::GetCurrentTime();
		fprintf(m_FicEnr,"=> Arrt %s\n\n",time.Format("%d/%m/%Y %H:%M:%S"));
		fflush(m_FicEnr);
		((CButton*)GetDlgItem ( IDC_BUTTON_BF_ENR))->SetWindowText("Enregistrer");
	}

	UpdateData(FALSE);
}

void COngBF::OnButtonBfVoirEnr() 
{
	// TODO: Add your control notification handler code here
	CString LigneComm;
	LigneComm.Format("notepad.exe %s",m_strPathName);
	WinExec(LigneComm,SW_SHOW);
}

void COngBF::OnButtong1() 
{
	// TODO: Add your control notification handler code here
	CEditTitre titre;
	int resp = titre.DoModal();
	if (resp == IDOK)
	{
		m_scopeBFEntCouple.SetCaption(titre.m_strTitre);
		UpdateData(TRUE);
	}	
}

void COngBF::OnButtong2() 
{
	// TODO: Add your control notification handler code here
	CEditTitre titre;
	int resp = titre.DoModal();
	if (resp == IDOK)
	{
		m_scopeBFSortCouple.SetCaption(titre.m_strTitre);
		UpdateData(TRUE);
	}
}

void COngBF::OnButtong3() 
{
	// TODO: Add your control notification handler code here
	CEditTitre titre;
	int resp = titre.DoModal();
	if (resp == IDOK)
	{
		m_scopeBFEntVitesse.SetCaption(titre.m_strTitre);
		UpdateData(TRUE);
	}
}

void COngBF::OnButtong4() 
{
	// TODO: Add your control notification handler code here
	CEditTitre titre;
	int resp = titre.DoModal();
	if (resp == IDOK)
	{
		m_scopeBFSortVitesse.SetCaption(titre.m_strTitre);
		UpdateData(TRUE);
	}
}

void COngBF::OnButtonDiagCoeffV() 
{
	// TODO: Add your control notification handler code here
	if (coeffV.DoModal() == IDOK)
	{
		bps_v = coeffV.m_fbps;
		ti_v = coeffV.m_fti;
		td_v = coeffV.m_ftd;
		ka_v = coeffV.m_fka;
	}
		
	m_strCoeffV.Format("Bp_v=%.2f Ti_v=%.2f Td_v=%.2f Ka_v=%.2f",
		bps_v,ti_v,td_v,ka_v);

	if (m_bEnr)
	{
		fprintf(m_FicEnr,"=> Nouveaux coefficients de rgulation pour la vitesse : %s\n",
				m_strCoeffV);
		fflush(m_FicEnr);
	}

	UpdateData(FALSE);
}
