// OngBO.cpp : implementation file
//

#include "stdafx.h"
#include "TER_Banc_Moteur.h"
#include "OngBO.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// COngBO dialog


COngBO::COngBO(CWnd* pParent /*=NULL*/)
	: CTabPageSSL(COngBO::IDD, pParent)
{
	//{{AFX_DATA_INIT(COngBO)
	m_iRadioBO = -1;
	m_strValSlider = _T("");
	m_editValComm = 0;
	m_strPeriode = _T("");
	//}}AFX_DATA_INIT
}


void COngBO::DoDataExchange(CDataExchange* pDX)
{
	CTabPageSSL::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(COngBO)
	DDX_Control(pDX, IDC_SLIDER_BO, m_sliderBO);
	DDX_Control(pDX, IDC_NTGRAPH_BO_ENT1, m_scopeBOEntCouple);
	DDX_Control(pDX, IDC_NTGRAPH_BO_ENT2, m_scopeBOEntVitesse);
	DDX_Control(pDX, IDC_NTGRAPH_BO_SORT1, m_scopeBOSortCouple);
	DDX_Control(pDX, IDC_NTGRAPH_BO_SORT2, m_scopeBOSortVitesse);
	DDX_Radio(pDX, IDC_RADIO_COUPLE_BO, m_iRadioBO);
	DDX_Text(pDX, IDC_STATIC_VAL_SLIDER, m_strValSlider);
	DDX_Text(pDX, IDC_EDIT_VAL_COMM, m_editValComm);
	DDV_MinMaxInt(pDX, m_editValComm, 0, 100);
	DDX_Text(pDX, IDC_STATIC_PERIODE, m_strPeriode);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(COngBO, CTabPageSSL)
	//{{AFX_MSG_MAP(COngBO)
	ON_WM_HSCROLL()
	ON_BN_CLICKED(IDC_RADIO_COUPLE_BO, OnRadioCoupleBo)
	ON_BN_CLICKED(IDC_RADIO_VITESSE_BO, OnRadioVitesseBo)
	ON_BN_CLICKED(IDC_BUTTON_COMM, OnButtonComm)
	ON_BN_CLICKED(IDC_BUTTON_ENR, OnButtonEnr)
	ON_BN_CLICKED(IDC_BUTTON_VOIR_ENR, OnButtonVoirEnr)
	ON_BN_CLICKED(IDC_BUTTONG1, OnButtong1)
	ON_BN_CLICKED(IDC_BUTTONG2, OnButtong2)
	ON_BN_CLICKED(IDC_BUTTONG3, OnButtong3)
	ON_BN_CLICKED(IDC_BUTTONG4, OnButtong4)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// COngBO message handlers

BOOL COngBO::OnInitDialog()
{
	
	CTabPageSSL::OnInitDialog ();
	
	InitGraph(&m_scopeBOEntCouple,"Mesure couple");
	InitGraph(&m_scopeBOEntVitesse,"Mesure vitesse");
	InitGraph(&m_scopeBOSortCouple,"Commande couple");
	InitGraph(&m_scopeBOSortVitesse,"Commande vitesse");	

	BOCouple = 0;
	BOVitesse = 0;
	m_iRadioBO = 0;

	m_bEnr = FALSE;

	m_strValSlider.Format("0 %c",'%');

	m_strPeriode.Format("Priode d'chantillonnage : %d ms",m_intPeriode);

	UpdateData(FALSE);
	
	FichierCreer = FALSE;
		
	return TRUE;
}

void COngBO::InitGraph(CNTGraph *g, LPCTSTR TitreGraphe, LPCTSTR AnnoLabel, 
					   LPCTSTR AnnoLabel2)
{
	g->SetRange(0,100,0,100);
	g->SetYLabel("%");
	
	if (TitreGraphe!=NULL)
	{
		g->SetCaption(TitreGraphe);
	}

	if (AnnoLabel!=NULL)
	{
		g->AddAnnotation();
		g->SetAnnoLabelColor(RGB(192,192,255));
		g->SetAnnoLabelBkColor(RGB(0, 0, 64));
		g->SetAnnoLabelX(5);
		g->SetAnnoLabelY(80);
		g->SetAnnoLabelCaption(AnnoLabel);
	}

	if (AnnoLabel2!=NULL)
	{
		g->AddAnnotation();
		g->SetAnnoLabelColor(RGB(0,255,0));
		g->SetAnnoLabelBkColor(RGB(0, 0, 64));
		g->SetAnnoLabelX(5);
		g->SetAnnoLabelY(70);
		g->SetAnnoLabelCaption(AnnoLabel2);
	}

	// Customize Graph Properties 
	g->SetShowGrid(FALSE);
	g->SetAxisColor(RGB(192, 192, 255));
	g->SetGridColor(RGB(192, 192, 255));
	g->SetLabelColor (RGB(192, 192, 255));

	// Control's Frame and Plot area options
	g->SetPlotAreaColor(RGB(0, 0, 64));
	g->SetFrameStyle(1);

	g->SetElementWidth(1);
	g->SetElementLinetype(0); // 5 = NULL
	g->SetElementLineColor(RGB(192,192,255));
	g->SetElementPointColor(RGB(0,255,0));
	g->SetElementPointSymbol(0); // 1 = Point
	g->SetElementSolidPoint(TRUE);

	g->AddElement();
	g->SetElementWidth(1);
	g->SetElementLinetype(0); // 5 = NULL
	g->SetElementLineColor(RGB(0,255,0));
	g->SetElementPointColor(RGB(0,255,0));
	g->SetElementPointSymbol(0); // 1 = Point
	g->SetElementSolidPoint(TRUE);

	m_bRedemarrer = TRUE;

}

void COngBO::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	// TODO: Add your message handler code here and/or call default
	

	if ( (CSliderCtrl*)pScrollBar == &m_sliderBO)
	{
		if (m_iRadioBO == 0)
		{
			BOCouple = m_sliderBO.GetPos();
		}
		else
		{
			BOVitesse = m_sliderBO.GetPos();
		}
	}		
	
	m_strValSlider.Format("%d %c",m_sliderBO.GetPos(),'%');
	UpdateData(FALSE);

	m_bRedemarrer = TRUE;

	CTabPageSSL::OnHScroll(nSBCode, nPos, pScrollBar);
}

void COngBO::OnRadioCoupleBo() 
{
	// TODO: Add your control notification handler code here
	m_sliderBO.SetPos(BOCouple);
	UpdateData(TRUE);
	m_strValSlider.Format("%d %c",BOCouple,'%');
	UpdateData(FALSE);
	m_bRedemarrer = TRUE;
}

void COngBO::OnRadioVitesseBo() 
{
	// TODO: Add your control notification handler code here
	m_sliderBO.SetPos(BOVitesse);
	UpdateData(TRUE);
	m_strValSlider.Format("%d %c",BOVitesse,'%');
	UpdateData(FALSE);
	m_bRedemarrer = TRUE;
}

void COngBO::OnButtonComm() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);

	if (m_editValComm<0 || m_editValComm>100)
		return;

	if (m_iRadioBO == 0)
	{
		BOCouple = m_editValComm;
		m_sliderBO.SetPos(BOCouple);
	}
	else
	{
		BOVitesse = m_editValComm;
		m_sliderBO.SetPos(BOVitesse);
	}
	m_strValSlider.Format("%d %c",m_sliderBO.GetPos(),'%');
	UpdateData(FALSE);

	m_bRedemarrer = TRUE;
}

void COngBO::OnButtonEnr() 
{
	// TODO: Add your control notification handler code here

	if (!m_bEnr)
	{
		if (FichierCreer)
		{
			m_bEnr = TRUE;
			((CButton*)GetDlgItem ( IDC_BUTTON_ENR))->SetWindowText("Arrter");

			CTime time = CTime::GetCurrentTime();
			fprintf(m_FicEnr,"=> Dmarrage %s\n",time.Format("%d/%m/%Y %H:%M:%S"));
		}
		else
		{
			CFileDialog saveDlg(FALSE,"txt",NULL,OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT,
				"Fichier texte (*.*)|*.*||");

			if (saveDlg.DoModal()==IDOK)
				{
					FichierCreer = TRUE;
					((CButton*)GetDlgItem ( IDC_BUTTON_VOIR_ENR))->EnableWindow(TRUE);
					
					m_bEnr = TRUE;
					((CButton*)GetDlgItem ( IDC_BUTTON_ENR))->SetWindowText("Arrter");

					m_strPathName = saveDlg.GetPathName();
		
					m_FicEnr = fopen(m_strPathName, "w");
	
					CTime time = CTime::GetCurrentTime();

					fprintf(m_FicEnr,"Fichiers de log pour la boucle ouverte.\n\n");
					fprintf(m_FicEnr,"Mesure_couple\tMesure_vitesse\tCommande_couple\tCommande_vitesse\n\n");
					fprintf(m_FicEnr,"=> Dmarrage %s\n",time.Format("%d/%m/%Y %H:%M:%S"));
				}
		}
	}
	else
	{
		m_bEnr = FALSE;

		CTime time = CTime::GetCurrentTime();
		fprintf(m_FicEnr,"=> Arrt %s\n\n",time.Format("%d/%m/%Y %H:%M:%S"));
		fflush(m_FicEnr);
		((CButton*)GetDlgItem ( IDC_BUTTON_ENR))->SetWindowText("Enregistrer");
	}

	UpdateData(FALSE);
}

void COngBO::OnButtonVoirEnr() 
{
	// TODO: Add your control notification handler code here
	CString LigneComm;
	LigneComm.Format("notepad.exe %s",m_strPathName);
	WinExec(LigneComm,SW_SHOW);
}

void COngBO::OnButtong1() 
{
	// TODO: Add your control notification handler code here
	CEditTitre titre;
	int resp = titre.DoModal();
	if (resp == IDOK)
	{
		m_scopeBOEntCouple.SetCaption(titre.m_strTitre);
		UpdateData(TRUE);
	}
}

void COngBO::OnButtong2() 
{
	// TODO: Add your control notification handler code here
	CEditTitre titre;
	int resp = titre.DoModal();
	if (resp == IDOK)
	{
		m_scopeBOSortCouple.SetCaption(titre.m_strTitre);
		UpdateData(TRUE);
	}
}

void COngBO::OnButtong3() 
{
	// TODO: Add your control notification handler code here
	CEditTitre titre;
	int resp = titre.DoModal();
	if (resp == IDOK)
	{
		m_scopeBOEntVitesse.SetCaption(titre.m_strTitre);
		UpdateData(TRUE);
	}
}

void COngBO::OnButtong4() 
{
	// TODO: Add your control notification handler code here
	CEditTitre titre;
	int resp = titre.DoModal();
	if (resp == IDOK)
	{
		m_scopeBOSortVitesse.SetCaption(titre.m_strTitre);
		UpdateData(TRUE);
	}	
}
